/**
 * 
 */
package de.mcs.tools.sps.emulator.client;

import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.cert.X509Certificate;

import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;
import javax.ws.rs.client.Client;
import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Entity;
import javax.ws.rs.client.Invocation.Builder;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.MediaType;

import de.mcs.tools.sps.emulator.model.WebSessionModel;

/**
 * @author w.klaas
 *
 */
public class SPSEmulatorClient {

  private Builder invocationBuilder;

  /**
   * @throws NoSuchAlgorithmException
   * @throws KeyManagementException
   * 
   */
  public SPSEmulatorClient(String url) throws NoSuchAlgorithmException, KeyManagementException {
    TrustManager[] noopTrustManager = new TrustManager[] { new X509TrustManager() {

      @Override
      public X509Certificate[] getAcceptedIssuers() {
        return null;
      }

      @Override
      public void checkClientTrusted(java.security.cert.X509Certificate[] certs, String authType) {
      }

      @Override
      public void checkServerTrusted(java.security.cert.X509Certificate[] certs, String authType) {
      }
    } };

    javax.net.ssl.HttpsURLConnection.setDefaultHostnameVerifier(new javax.net.ssl.HostnameVerifier() {

      public boolean verify(String hostname, javax.net.ssl.SSLSession sslSession) {
        return true;
      }
    });

    SSLContext sc = SSLContext.getInstance("ssl");
    sc.init(null, noopTrustManager, null);

    Client client = ClientBuilder.newBuilder().sslContext(sc).build();
    WebTarget webTarget = client.target(url);
    invocationBuilder = webTarget.request(MediaType.APPLICATION_JSON);
  }

  public WebSessionModel getNewWebsession() {
    return invocationBuilder.get(WebSessionModel.class);
  }

  public WebSessionModel processWebSession(WebSessionModel webSessionModel) {
    return invocationBuilder.post(Entity.entity(webSessionModel, MediaType.APPLICATION_JSON), WebSessionModel.class);
  }

}
