/**
 * 
 */
package de.mcs.tools.sps.emulator;

/**
 * @author w.klaas
 *
 */
public abstract class SPSCommandDataImpl implements SPSCommandData {

  String name;
  String mnemonic;
  byte cmdByte;
  SPSCommand command;

  public SPSCommandDataImpl() {
  }

  @Override
  public SPSCommand getCommand() {
    return command;
  }

  @Override
  public String getName() {
    return name;
  }

  @Override
  public String getMnemonic() {
    return mnemonic;
  }

  /**
   * @return the cmdByte
   */
  @Override
  public byte getCommandByte() {
    return cmdByte;
  }

  /**
   * @param cmdByte
   *          the cmdByte to set
   * @return this instance
   */
  public SPSCommandDataImpl setCommandByte(byte cmdByte) {
    this.cmdByte = cmdByte;
    return this;
  }

  /**
   * @param name
   *          the name to set
   * @return this instance
   */
  public SPSCommandDataImpl setName(String name) {
    this.name = name;
    return this;
  }

  /**
   * @param mnemonic
   *          the mnemonic to set
   * @return this instance
   */
  public SPSCommandDataImpl setMnemonic(String mnemonic) {
    this.mnemonic = mnemonic;
    return this;
  }

  /**
   * @param command
   *          the command to set
   * @return this instance
   */
  public SPSCommandDataImpl setCommand(SPSCommand command) {
    this.command = command;
    return this;
  }

  /**
   * @param command
   *          the command to set
   * @return this instance
   */
  public byte getData() {
    return (byte) (getCommandByte() & (byte) 0x0F);
  }

  @Override
  public String toString() {
    return String.format("%s (%s): %.2X", getMnemonic(), getName(), getCommandByte());
  }

  @Override
  public abstract EmulatorOutput doWork(EmulatorInput input, EmulatorInternals internals, EmulatorOutput output);

}
