/**
 * MCS Media Computer Software
 * Copyright 2019 by Wilfried Klaas
 * Project: SPSEmulator
 * File: WebEmulatorApp.java
 * EMail: W.Klaas@gmx.de
 * Created: 29.01.2019 wklaa_000
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 */
package de.mcs.tools.sps.emulator;

import de.mcs.tools.sps.emulator.resources.EmulatorResource;
import io.dropwizard.Application;
import io.dropwizard.setup.Environment;

/**
 * @author wklaa_000
 *
 */
public class WebEmulatorApplication extends Application<WebEmulatorConfiguration> {

  public static void main(String[] args) throws Exception {
    new WebEmulatorApplication().run(args);
  }

  @Override
  public void run(WebEmulatorConfiguration configuration, Environment environment) throws Exception {
    final EmulatorResource resource = new EmulatorResource();
    environment.jersey().register(resource);
    environment.healthChecks().register("BaseHealthCheck", new BaseHealthCheck());
  }

}
