package de.mcs.tools.sps.emulator.model;

import java.util.ArrayList;
import java.util.List;

public class WorkingModel {

  public enum WORKINGSTATE {
    NN, EMULATE
  }

  private byte registerA;
  private byte registerB;
  private byte registerC;
  private byte registerD;
  private byte registerE;
  private byte registerF;

  private byte page;
  private short raddress;
  private short address;

  private List<Integer> stack = new ArrayList<>();
  private WORKINGSTATE workingstate;

  @Override
  public String toString() {
    StringBuilder b = new StringBuilder();
    b.append(String.format(
        "%s:[registerA: 0x%02x, registerB: 0x%02x, registerC: 0x%02x, registerD: 0x%02x, registerE: 0x%02x, registerF: 0x%02x, page: 0x%02x, address: 0x%04x, raddress: 0x%04x, stack: %d ]",
        this.getClass().getSimpleName(), registerA, registerB, registerC, registerD, registerE, registerF, page,
        address, raddress, stack.size()));
    return b.toString();
  }

  /**
   * @return the registerA
   */
  public byte getRegisterA() {
    return registerA;
  }

  /**
   * @param registerA
   *          the registerA to set
   */
  public void setRegisterA(byte registerA) {
    this.registerA = registerA;
  }

  /**
   * @return the registerB
   */
  public byte getRegisterB() {
    return registerB;
  }

  /**
   * @param registerB
   *          the registerB to set
   */
  public void setRegisterB(byte registerB) {
    this.registerB = registerB;
  }

  /**
   * @return the registerC
   */
  public byte getRegisterC() {
    return registerC;
  }

  /**
   * @param registerC
   *          the registerC to set
   */
  public void setRegisterC(byte registerC) {
    this.registerC = registerC;
  }

  /**
   * @return the registerD
   */
  public byte getRegisterD() {
    return registerD;
  }

  /**
   * @param registerD
   *          the registerD to set
   */
  public void setRegisterD(byte registerD) {
    this.registerD = registerD;
  }

  /**
   * @return the page
   */
  public byte getPage() {
    return page;
  }

  /**
   * @param page
   *          the page to set
   */
  public void setPage(byte page) {
    this.page = page;
  }

  /**
   * @return the raddress
   */
  public short getRaddress() {
    return raddress;
  }

  /**
   * @param raddress
   *          the raddress to set
   */
  public void setRaddress(short raddress) {
    this.raddress = raddress;
  }

  /**
   * @return the address
   */
  public short getAddress() {
    return address;
  }

  /**
   * @param address
   *          the address to set
   */
  public void setAddress(short address) {
    this.address = address;
  }

  /**
   * @return the registerE
   */
  public byte getRegisterE() {
    return registerE;
  }

  /**
   * @param registerE
   *          the registerE to set
   */
  public void setRegisterE(byte registerE) {
    this.registerE = registerE;
  }

  /**
   * @return the registerF
   */
  public byte getRegisterF() {
    return registerF;
  }

  /**
   * @param registerF
   *          the registerF to set
   */
  public void setRegisterF(byte registerF) {
    this.registerF = registerF;
  }

  /**
   * @return the stack
   */
  public List<Integer> getStack() {
    return stack;
  }

  /**
   * @param stack
   *          the stack to set
   */
  public void setStack(List<Integer> stack) {
    this.stack = stack;
  }

  /**
   * @return the workingstate
   */
  public WORKINGSTATE getWorkingstate() {
    return workingstate;
  }

  /**
   * @param workingstate
   *          the workingstate to set
   */
  public void setWorkingstate(WORKINGSTATE workingstate) {
    this.workingstate = workingstate;
  }

}
