package de.mcs.utils;
/**
 * 
 */

/**
 * @author w.klaas
 */
public class Macro {

  private String value;
  private String name;

  /**
   * Constructs a new macro
   * 
   * @param macroName
   *          name of the macro
   * @param value
   *          value for substitution
   */
  public Macro(String macroName, String value) {
    this.name = macroName;
    this.value = value;
  }

  /**
   * @return the value for substitution
   */
  public String getValue() {
    return value;
  }

  /**
   * @param value
   *          setting a new value for this macro
   */
  public void setValue(String value) {
    this.value = value;
  }

  /**
   * @return name of this macro.
   */
  public String getMacroName() {
    return name;
  }

  /**
   * @return same as getMacroName(), but with the {} delimiter.
   */
  public String getMacroDefinition() {
    StringBuilder b = new StringBuilder();
    b.append('{');
    b.append(getMacroName());
    b.append('}');
    return b.toString();
  }

  /*
   * (non-Javadoc)
   * @see java.lang.Object#toString()
   */
  @Override
  public String toString() {
    return String.format("%s=\"%s\"", getMacroDefinition(), getValue());
  }

}
